/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package net.locusworks.discord.eighttrack.database.entities;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author isaac
 */
@Entity
@Table(name = "discord_guild", catalog = "eighttrack", schema = "")
@NamedQueries({
    @NamedQuery(name = "DiscordGuild.findAll", query = "SELECT d FROM DiscordGuild d")})
public class DiscordGuild implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Long id;
    @Basic(optional = false)
    @Column(name = "guild_id")
    private long guildId;
    @Basic(optional = false)
    @Column(name = "guild_name")
    private String guildName;
    @Column(name = "date_joined")
    @Temporal(TemporalType.TIMESTAMP)
    private Date dateJoined;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "guild")
    private List<GuildSong> guildSongList;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "guild")
    private List<GuildPlaylist> guildPlaylistList;

    public DiscordGuild() {
    }

    public DiscordGuild(Long id) {
        this.id = id;
    }

    public DiscordGuild(Long id, long guildId, String guildName) {
        this.id = id;
        this.guildId = guildId;
        this.guildName = guildName;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public long getGuildId() {
        return guildId;
    }

    public void setGuildId(long guildId) {
        this.guildId = guildId;
    }

    public String getGuildName() {
        return guildName;
    }

    public void setGuildName(String guildName) {
        this.guildName = guildName;
    }

    public Date getDateJoined() {
        return dateJoined;
    }

    public void setDateJoined(Date dateJoined) {
        this.dateJoined = dateJoined;
    }

    public List<GuildSong> getGuildSongList() {
        return guildSongList;
    }

    public void setGuildSongList(List<GuildSong> guildSongList) {
        this.guildSongList = guildSongList;
    }

    public List<GuildPlaylist> getGuildPlaylistList() {
        return guildPlaylistList;
    }

    public void setGuildPlaylistList(List<GuildPlaylist> guildPlaylistList) {
        this.guildPlaylistList = guildPlaylistList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DiscordGuild)) {
            return false;
        }
        DiscordGuild other = (DiscordGuild) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "net.locusworks.discord.eighttrack.database.entities.DiscordGuild[ id=" + id + " ]";
    }
    
}
